local global_funcs = {}
--vars.isUseColor = gkini.ReadInt("SLM", "UseColor", 1)==1 --OBSOLETE
--vars.SortPresetsBy = gkini.ReadInt("SLM", "SortPresetsBy", 1) --OBSOLETE

--[=[ NOTATION
vars.key={
	format = (string), --'Int' or 'String' how to save in config file
	default = (int or string depending on format), --default setting
	key = (string), --key to write var in config file
	bool = (), -- (optional) if the value is equal to this then treat as true, otherwise false -- don't set to nil or false
} --]=]


local vars = {
	IsUseColor={
		format = "Int",
		default = 1,
		key = "UseColor",
		bool = 1,
	},
	SortPresetsBy={
		format = "Int",
		default = 1,
		key = "SortPresetsBy",
	},
	IsCaseInsensitive={
		format = "Int",
		default = 1,
		key = "CaseInsensitive",
		bool = 1,
	},
	IsPatternMatching={
		format = "Int",
		default = 0,
		key = "PatternMatching",
		bool = 1,
	},
	IsOnlyAvailable={
		format = "Int",
		default = 0,
		key = "ShowOnlyAvailable",
		bool = 1,
	},
	IsEnhancedPurchase={
		format = "Int",
		default = 1,
		key = "EnhancedPurchase",
		bool = 1,
	},
	IsDoubleClickBuy={
		format = "Int",
		default = 0,
		key = "DoubleClickBuy",
		bool = 1,
	},
	DoubleClickDelay={
		format = "Int",
		default = 600,
		key = "DoubleClickDelay"
	},
	IsGMT={
		format = "Int",
		default = 0,
		key = "IsGMT",
		bool = 1,
	},
}

local function read_val(key)
	local val = gkini["Read"..(vars[key].format or "String")]("SLM", vars[key].key, vars[key].default)
	if vars[key].bool then val = val == vars[key].bool end
	
	return val
end

for k,v in pairs(vars) do v.value = read_val(k) end

function global_funcs.GetVars(key)
	if vars[key] then
		vars[key].value = vars[key].value==nil and read_val(key) or vars[key].value
		return vars[key].value
	else --[[console_print'vars key not found!';]] return end
end

function global_funcs.SaveVars(key, val)
	local function save_val(key, val)
		vars[key].value = val
		
		if val==true then
			val = vars[key].bool or (vars[key].format=="Int" and 1 or 'true')
		elseif val==false then
			val = vars[key].format=="Int" and 0 or 'false'
		end
		
		gkini["Write"..(vars[key].format or "String")]("SLM", vars[key].key, val)
		
		return val
	end

	if vars[key] and val~=nil then
		return save_val(key, val)
	else return end
end

function global_funcs.GetDefault(key) return vars[key] and vars[key].default end

return global_funcs, vars